bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

touch -c file/


From: Eric Blake
Subject: touch -c file/
Date: Wed, 21 Oct 2009 06:26:27 -0600
User-agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.23) Gecko/20090812 Thunderbird/2.0.0.23 Mnenhy/0.7.6.666

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

OK to apply?  This test fails on Solaris 9 until you import the latest gnulib.

- --
Don't work too hard, make some time for fun as well!

Eric Blake             address@hidden
-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (Cygwin)
Comment: Public key at home.comcast.net/~ericblake/eblake.gpg
Comment: Using GnuPG with Mozilla - http://enigmail.mozdev.org/

iEYEARECAAYFAkre/fMACgkQ84KuGfSFAYA91gCgvavGVc7R40juvNLBr5ogq8Fv
6uYAoLOIPTCZ1T4nTpnqWnIF3qXfoJlU
=+Yc+
-----END PGP SIGNATURE-----
>From 9d85955b703cbcfc021e5aff9fa495e9672a40c4 Mon Sep 17 00:00:00 2001
From: Eric Blake <address@hidden>
Date: Wed, 21 Oct 2009 06:23:28 -0600
Subject: [PATCH] tests: ensure touch honors trailing slash

* tests/touch/trailing-slash: New test.
* tests/Makefile.am (TESTS): Run it.
---
 tests/Makefile.am          |    1 +
 tests/touch/trailing-slash |   66 ++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 67 insertions(+), 0 deletions(-)
 create mode 100755 tests/touch/trailing-slash

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 751db1c..e389f22 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -451,6 +451,7 @@ TESTS =                                             \
   touch/obsolescent                            \
   touch/read-only                              \
   touch/relative                               \
+  touch/trailing-slash                         \
   $(root_tests)

 pr_data =                                      \
diff --git a/tests/touch/trailing-slash b/tests/touch/trailing-slash
new file mode 100755
index 0000000..7478765
--- /dev/null
+++ b/tests/touch/trailing-slash
@@ -0,0 +1,66 @@
+#!/bin/sh
+# Ensure that touch honors trailing slash.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  touch --version
+fi
+
+. $srcdir/test-lib.sh
+
+ln -s nowhere dangling || framework_failure
+ln -s loop loop || framework_failure
+touch file || framework_failure
+ln -s file link1 || framework_failure
+mkdir dir || framework_failure
+ln -s dir link2 || framework_failure
+
+fail=0
+
+# Trailing slash can only appear on directory or symlink-to-directory.
+# Up through coreutils 8.0, Solaris 9 failed these tests.
+touch no-file/ && fail=1
+touch file/ && fail=1
+touch dangling/ && fail=1
+touch loop/ && fail=1
+touch link1/ && fail=1
+touch dir/ || fail=1
+
+# -c silences ENOENT, but not ENOTDIR or ELOOP
+touch -c no-file/ || fail=1
+touch -c file/ && fail=1
+touch -c dangling/ || fail=1
+touch -c loop/ && fail=1
+touch -c link1/ && fail=1
+touch -c dir/ || fail=1
+test -f no-file && fail=1
+test -f nowhere && fail=1
+
+# Trailing slash dereferences a symlink, even with -h.
+# mtime is sufficient to show pass (besides, lstat changes atime of
+# symlinks and directories under Cygwin 1.5).
+touch -d 2009-10-10 -h link2/ || fail=1
+case `stat --format=%y dir` in
+  2009-10-10*) ;;
+  *) fail=1 ;;
+esac
+case `stat --format=%y link2` in
+  2009-10-10*) fail=1;;
+esac
+
+Exit $fail
-- 
1.6.5.rc1


reply via email to

[Prev in Thread] Current Thread [Next in Thread]